"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchPageOrAsyncSuccessCase = exports.fetchPageOrAsyncFailureCase = exports.notifyCase = exports.dismissFirstNotificationCase = void 0;

var _actions = require("./actions");

var _uiReductions = require("./ui-reductions");

// eslint-disable-next-line no-unused-vars
var dismissFirstNotificationCase = function dismissFirstNotificationCase(uiState, payload) {
  return [_actions.SHARYN_DISMISS_FIRST_NOTIFICATION, function () {
    return (0, _uiReductions.removeFirstNotification)(uiState);
  }];
};

exports.dismissFirstNotificationCase = dismissFirstNotificationCase;

var notifyCase = function notifyCase(uiState, payload) {
  return [_actions.SHARYN_NOTIFY, function () {
    return (0, _uiReductions.addOneNotification)(uiState, payload);
  }];
};

exports.notifyCase = notifyCase;

var fetchPageOrAsyncFailureCase = function fetchPageOrAsyncFailureCase(uiState, payload) {
  return [[_actions.SHARYN_FETCH_PAGE_FAILURE, _actions.SHARYN_ASYNC_FAILURE], function () {
    return (0, _uiReductions.addOneNotification)(uiState, payload.notification);
  }];
};

exports.fetchPageOrAsyncFailureCase = fetchPageOrAsyncFailureCase;

var fetchPageOrAsyncSuccessCase = function fetchPageOrAsyncSuccessCase(uiState, payload) {
  return [[_actions.SHARYN_FETCH_PAGE_SUCCESS, _actions.SHARYN_ASYNC_SUCCESS], function () {
    return (0, _uiReductions.addMultipleNotifications)(uiState, payload.notifications);
  }];
};

exports.fetchPageOrAsyncSuccessCase = fetchPageOrAsyncSuccessCase;